#ifndef GOAP_PLANNER_HPP
#define GOAP_PLANNER_HPP

#include "action.hpp"
#include "actor_world_state.hpp"
#include "goal.hpp"
#include "godot_cpp/variant/packed_int32_array.hpp"
#include <godot_cpp/templates/vector.hpp>
#include <godot_cpp/classes/node.hpp>

namespace gd = godot;

namespace goap {
typedef gd::Vector<Action> Plan;

class Planner : public gd::Node {
    GDCLASS(Planner, gd::Node);
    static void _bind_methods();
public:
    virtual void _enter_tree() override;

    Plan plan_for_goal(gd::Ref<Goal> goal);

    void set_actions(gd::PackedInt32Array array);
    gd::PackedInt32Array get_actions() const;
private:
    ActorWorldState *world_state{nullptr};
    gd::Vector<Action const *> actions;
};
}

#endif // !GOAP_PLANNER_HPP
